VERSION 5.00
Begin VB.UserControl CustomTextBox 
   ClientHeight    =   615
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LockControls    =   -1  'True
   ScaleHeight     =   41
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   Begin VB.Timer tmrAutoType 
      Enabled         =   0   'False
      Left            =   4320
      Top             =   120
   End
   Begin VB.Timer tmrDelayType 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3840
      Top             =   120
   End
   Begin VB.TextBox TextBox 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3615
   End
End
Attribute VB_Name = "CustomTextBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private fBusy As Boolean
Private fBusyResize As Boolean

Public Enum DataTypes
  DataTypeText
  DataTypeInteger
  DataTypeFixed1
  DataTypeFixed2
  DataTypeFixed3
  DataTypeFixed4
  DataTypeCurrency
  DataTypeDate
  DataTypeTime
  DataTypeDateTime
End Enum

Private WithEvents objFont As StdFont
Attribute objFont.VB_VarHelpID = -1
Private varEnabled As Boolean
Private varLocked As Boolean
Private varBackColor As Long
Private varForeColor As Long
Private varCausesValidation As Boolean

Private varFreezeEvents As Boolean
Private varAutoSelect As Boolean
Private varMask As String
Private varDataType As DataTypes
Private varValue As Variant

Private varDelayTypeTime As Long, varDelayTypeSelect As Boolean, varDelayTypeLast As Long
Private varAutoTypeTime As Long, varAutoTypeSelect As Boolean, varAutoTypeLast As Long, varAutoTypeCnt As Long

Private Declare Function InternalGetTickCount Lib "kernel32" Alias "GetTickCount" () As Long

Private Const CharsDecDigits As String = "0123456789"
Private Const CharsHexDigits As String = "0123456789ABCDEF"
Private Const CharsLetters As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

Private varCurrentMask As String
Private varPosted As Boolean, varLastKeyAscii As Long, varLastSelStart As Long, varLastSelLength As Long
Private varKeyInputFlag As Boolean

Public Event Change()
Attribute Change.VB_Description = "  ."
Attribute Change.VB_MemberFlags = "200"
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "   ."
Attribute KeyDown.VB_UserMemId = -602
Public Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "   ."
Attribute KeyPress.VB_UserMemId = -603
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "   ."
Attribute KeyUp.VB_UserMemId = -604
Public Event Validate(Cancel As Boolean)
Attribute Validate.VB_Description = "  ."
Public Event DelayType()
Attribute DelayType.VB_Description = "   .           ."
Public Event AutoType()
Attribute AutoType.VB_Description = "  .        ,        ."

Private Function FormatValue(ByVal Value As Variant, ByVal DataType As DataTypes) As String
Dim PI As String, PF As String, S As String
If IsNull(Value) Then
  FormatValue = vbNullString
  Exit Function
End If
Select Case DataType
  Case DataTypes.DataTypeText
    FormatValue = Value
  Case DataTypes.DataTypeInteger
    FormatValue = Trim$(Str$(Value))
  Case DataTypes.DataTypeFixed1
    S = Trim$(Str$(Abs(Value)))
    If InStr(S, ".") = 0 Then S = S & "."
    If InStr(S, ".") = 1 Then S = "0" & S
    PI = Left$(S, InStr(S, ".") - 1)
    PF = Left$(Mid$(S, InStr(S, ".") + 1) & "0", 1)
    FormatValue = IIf(Value < 0, "-", vbNullString) & PI & "." & PF
  Case DataTypes.DataTypeFixed2
    S = Trim$(Str$(Abs(Value)))
    If InStr(S, ".") = 0 Then S = S & "."
    If InStr(S, ".") = 1 Then S = "0" & S
    PI = Left$(S, InStr(S, ".") - 1)
    PF = Left$(Mid$(S, InStr(S, ".") + 1) & "00", 2)
    FormatValue = IIf(Value < 0, "-", vbNullString) & PI & "." & PF
  Case DataTypes.DataTypeFixed3
    S = Trim$(Str$(Abs(Value)))
    If InStr(S, ".") = 0 Then S = S & "."
    If InStr(S, ".") = 1 Then S = "0" & S
    PI = Left$(S, InStr(S, ".") - 1)
    PF = Left$(Mid$(S, InStr(S, ".") + 1) & "000", 3)
    FormatValue = IIf(Value < 0, "-", vbNullString) & PI & "." & PF
  Case DataTypes.DataTypeFixed4
    S = Trim$(Str$(Abs(Value)))
    If InStr(S, ".") = 0 Then S = S & "."
    If InStr(S, ".") = 1 Then S = "0" & S
    PI = Left$(S, InStr(S, ".") - 1)
    PF = Left$(Mid$(S, InStr(S, ".") + 1) & "0000", 4)
    FormatValue = IIf(Value < 0, "-", vbNullString) & PI & "." & PF
  Case DataTypes.DataTypeCurrency
    PI = Trim$(Str$(Fix(Value)))
    PF = Right$("0000" & Trim$(Str$(Fix((Value - PI) * 10000&))), 4)
    FormatValue = IIf(Value < 0, "-", vbNullString) & PI & "." & Left$(PF, 2) & " "
  Case DataTypes.DataTypeDate
    FormatValue = Right$("00" & Trim$(Str$(Day(Value))), 2) & "." & Right$("00" & Trim$(Str$(Month(Value))), 2) & "." & Right$("0000" & Trim$(Str$(Year(Value))), 4)
  Case DataTypes.DataTypeTime
    FormatValue = Right$("00" & Trim$(Str$(Hour(Value))), 2) & ":" & Right$("00" & Trim$(Str$(Minute(Value))), 2) & "." & Right$("00" & Trim$(Str$(Second(Value))), 2)
  Case DataTypes.DataTypeDateTime
    FormatValue = Right$("00" & Trim$(Str$(Day(Value))), 2) & "." & Right$("00" & Trim$(Str$(Month(Value))), 2) & "." & Right$("0000" & Trim$(Str$(Year(Value))), 4) & " " & Right$("00" & Trim$(Str$(Hour(Value))), 2) & ":" & Right$("00" & Trim$(Str$(Minute(Value))), 2) & "." & Right$("00" & Trim$(Str$(Second(Value))), 2)
End Select
End Function

Private Function ParseValue(ByVal Value As String, ByVal DataType As DataTypes) As Variant
Dim D As String, T As String
If DataType <> DataTypeText Then
  If Len(Value) = 0 Then
    ParseValue = Null
    Exit Function
  End If
End If
Select Case DataType
  Case DataTypes.DataTypeText
    ParseValue = CStr(Value)
  Case DataTypes.DataTypeInteger
    ParseValue = CLng(Val(Trim$(Value)))
  Case DataTypes.DataTypeFixed1
    ParseValue = CDbl(Val(Trim$(Value)))
  Case DataTypes.DataTypeFixed2
    ParseValue = CDbl(Val(Trim$(Value)))
  Case DataTypes.DataTypeFixed3
    ParseValue = CDbl(Val(Trim$(Value)))
  Case DataTypes.DataTypeFixed4
    ParseValue = CDbl(Val(Trim$(Value)))
  Case DataTypes.DataTypeCurrency
    ParseValue = CCur(Val(Trim$(Value)))
  Case DataTypes.DataTypeDate
    D = Value
    If Len(D) = 10 Then
      If Mid$(D, 3, 1) = "." And Mid$(D, 6, 1) = "." Then
        If IsNumeric(Mid$(D, 1, 2)) And IsNumeric(Mid$(D, 4, 2)) And IsNumeric(Mid$(D, 7, 4)) Then
          ParseValue = DateSerial(Val(Mid$(D, 7, 4)), Val(Mid$(D, 4, 2)), Val(Mid$(D, 1, 2)))
        End If
      End If
    End If
  Case DataTypes.DataTypeTime
    T = Value
    If Len(T) = 8 Then
      If Mid$(D, 3, 1) = ":" And Mid$(D, 6, 1) = ":" Then
        If IsNumeric(Mid$(D, 1, 2)) And IsNumeric(Mid$(D, 4, 2)) And IsNumeric(Mid$(D, 7, 2)) Then
          ParseValue = TimeSerial(Val(Mid$(D, 1, 2)), Val(Mid$(D, 4, 2)), Val(Mid$(D, 7, 2)))
        End If
      End If
    ElseIf Len(T) = 5 Then
      If Mid$(D, 3, 1) = ":" Then
        If IsNumeric(Mid$(D, 1, 2)) And IsNumeric(Mid$(D, 4, 2)) Then
          ParseValue = TimeSerial(Val(Mid$(D, 1, 2)), Val(Mid$(D, 4, 2)), 0)
        End If
      End If
    End If
  Case DataTypes.DataTypeDateTime
    If InStr(Value, " ") > 0 Then
      D = Left$(Value, InStr(Value, " ") - 1)
      T = Mid$(Value, InStr(Value, " ") + 1)
    Else
      D = Value
    End If
    If Len(D) = 10 Then
      If Mid$(D, 3, 1) = "." And Mid$(D, 6, 1) = "." Then
        If IsNumeric(Mid$(D, 1, 2)) And IsNumeric(Mid$(D, 4, 2)) And IsNumeric(Mid$(D, 7, 4)) Then
          ParseValue = DateSerial(Val(Mid$(D, 7, 4)), Val(Mid$(D, 4, 2)), Val(Mid$(D, 1, 2)))
          If Len(T) = 8 Then
            If Mid$(D, 3, 1) = ":" And Mid$(D, 6, 1) = ":" Then
              If IsNumeric(Mid$(D, 1, 2)) And IsNumeric(Mid$(D, 4, 2)) And IsNumeric(Mid$(D, 7, 2)) Then
                ParseValue = ParseValue + TimeSerial(Val(Mid$(D, 1, 2)), Val(Mid$(D, 4, 2)), Val(Mid$(D, 7, 2)))
              End If
            End If
          ElseIf Len(T) = 5 Then
            If Mid$(D, 3, 1) = ":" Then
              If IsNumeric(Mid$(D, 1, 2)) And IsNumeric(Mid$(D, 4, 2)) Then
                ParseValue = ParseValue + TimeSerial(Val(Mid$(D, 1, 2)), Val(Mid$(D, 4, 2)), 0)
              End If
            End If
          End If
        End If
      End If
    End If
End Select
End Function

Private Function CheckMask(ByVal Value As String, ByVal Mask As String, Optional ByRef RightValue As String) As Boolean
RightValue = vbNullString
If Len(Mask) = 0 Then
  RightValue = Value
  CheckMask = True
  Exit Function
End If
Dim I As Long, C As String, M As String, P As Long, Z As String
If Len(Value) > Len(Mask) Then Exit Function
For I = 1 To Len(Mask)
  If I > Len(Value) Then Exit For
  C = Mid$(Value, I, 1)
  M = Mid$(Mask, I, 1)
  Select Case M
    Case "#" ' 
      Z = CharsDecDigits
    Case "&" ' 
      Z = CharsHexDigits
    Case "$" ' A...Z
      Z = CharsLetters
    Case "@" '  
      Z = CharsDecDigits & CharsLetters
    Case "!" ' 
      Z = vbNullChar
    Case Else
      Z = vbNullString
  End Select
  If Len(Z) = 0 Then
    If C <> M Then Exit Function
  Else
    If Z <> vbNullChar Then
      P = InStr(Z, UCase$(C))
      If P = 0 Then Exit Function
      Mid$(Value, I, 1) = Mid$(Z, P, 1)
    End If
  End If
Next I
RightValue = Value
CheckMask = True
End Function

Public Property Get InlineControl() As TextBox
Attribute InlineControl.VB_Description = "    ."
Attribute InlineControl.VB_MemberFlags = "400"
Set InlineControl = TextBox
End Property

Public Property Get DelayTypeTime() As Long
Attribute DelayTypeTime.VB_Description = "  ( )    . 0 -   ."
Attribute DelayTypeTime.VB_ProcData.VB_Invoke_Property = ";Behavior"
DelayTypeTime = varDelayTypeTime
End Property

Public Property Let DelayTypeTime(ByVal NewValue As Long)
varDelayTypeTime = NewValue
PropertyChanged "DelayTypeTime"
End Property

Public Property Get AutoTypeTime() As Long
Attribute AutoTypeTime.VB_Description = "  ( )   ,    . 0 -  ."
Attribute AutoTypeTime.VB_ProcData.VB_Invoke_Property = ";Behavior"
AutoTypeTime = varAutoTypeTime
End Property

Public Property Get DelayTypeSelect() As Boolean
Attribute DelayTypeSelect.VB_Description = "        ."
DelayTypeSelect = varDelayTypeSelect
End Property

Public Property Let DelayTypeSelect(ByVal NewValue As Boolean)
varDelayTypeSelect = NewValue
PropertyChanged "DelayTypeSelect"
End Property

Public Property Let AutoTypeTime(ByVal NewValue As Long)
varAutoTypeTime = NewValue
PropertyChanged "AutoTypeTime"
End Property

Public Property Get AutoTypeSelect() As Boolean
Attribute AutoTypeSelect.VB_Description = "        ."
AutoTypeSelect = varAutoTypeSelect
End Property

Public Property Let AutoTypeSelect(ByVal NewValue As Boolean)
varAutoTypeSelect = NewValue
PropertyChanged "AutoTypeSelect"
End Property

Public Property Get Alignment() As AlignmentConstants
Attribute Alignment.VB_Description = "  ."
Attribute Alignment.VB_ProcData.VB_Invoke_Property = ";Appearance"
Alignment = TextBox.Alignment
End Property

Public Property Let Alignment(ByVal NewValue As AlignmentConstants)
TextBox.Alignment = NewValue
PropertyChanged "Alignment"
End Property

Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = " ."
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Appearance"
MousePointer = TextBox.MousePointer
End Property

Public Property Let MousePointer(ByVal NewValue As MousePointerConstants)
TextBox.MousePointer = NewValue
PropertyChanged "MousePointer"
End Property

Public Property Get MouseIcon() As StdPicture
Attribute MouseIcon.VB_Description = " ."
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Appearance"
Set MouseIcon = TextBox.MouseIcon
End Property

Public Property Set MouseIcon(ByVal NewValue As StdPicture)
Set TextBox.MouseIcon = NewValue
PropertyChanged "MouseIcon"
End Property

Public Property Get AutoSelect() As Boolean
Attribute AutoSelect.VB_Description = "       ."
Attribute AutoSelect.VB_ProcData.VB_Invoke_Property = ";Behavior"
AutoSelect = varAutoSelect
End Property

Public Property Let AutoSelect(ByVal NewValue As Boolean)
varAutoSelect = NewValue
PropertyChanged "AutoSelect"
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "  ."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
BackColor = varBackColor
End Property

Public Property Let BackColor(ByVal NewValue As OLE_COLOR)
varBackColor = NewValue
RefreshControlState
PropertyChanged "BackColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "   ."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
ForeColor = varForeColor
End Property

Public Property Let ForeColor(ByVal NewValue As OLE_COLOR)
varForeColor = NewValue
RefreshControlState
PropertyChanged "ForeColor"
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_Description = ",   ."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Set Font = TextBox.Font
End Property

Public Property Set Font(ByVal NewValue As StdFont)
With TextBox.Font
  .Name = NewValue.Name
  .Charset = NewValue.Charset
  .Size = NewValue.Size
  .Weight = NewValue.Weight
  .Bold = NewValue.Bold
  .Italic = NewValue.Italic
  .Underline = NewValue.Underline
  .Strikethrough = NewValue.Strikethrough
End With
Set objFont = TextBox.Font
PropertyChanged "Font"
PropertyChanged "FontName"
PropertyChanged "FontSize"
PropertyChanged "FontBold"
PropertyChanged "FontItalic"
PropertyChanged "FontUnderline"
PropertyChanged "FontStrikethru"
End Property

Public Property Get FontName() As String
Attribute FontName.VB_Description = " ."
Attribute FontName.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute FontName.VB_MemberFlags = "400"
FontName = TextBox.FontName
End Property

Public Property Let FontName(ByVal NewValue As String)
TextBox.FontName = NewValue
Set objFont = TextBox.Font
PropertyChanged "FontName"
PropertyChanged "Font"
End Property

Public Property Get FontSize() As Single
Attribute FontSize.VB_Description = " ."
Attribute FontSize.VB_ProcData.VB_Invoke_Property = ";Font"
FontSize = TextBox.FontSize
End Property

Public Property Let FontSize(ByVal NewValue As Single)
TextBox.FontSize = NewValue
Set objFont = TextBox.Font
PropertyChanged "FontSize"
PropertyChanged "Font"
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "  ."
Attribute FontBold.VB_ProcData.VB_Invoke_Property = ";Font"
FontBold = TextBox.FontBold
End Property

Public Property Let FontBold(ByVal NewValue As Boolean)
TextBox.FontBold = NewValue
Set objFont = TextBox.Font
PropertyChanged "FontBold"
PropertyChanged "Font"
End Property

Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_Description = "  ."
Attribute FontItalic.VB_ProcData.VB_Invoke_Property = ";Font"
FontItalic = TextBox.FontItalic
End Property

Public Property Let FontItalic(ByVal NewValue As Boolean)
TextBox.FontItalic = NewValue
Set objFont = TextBox.Font
PropertyChanged "FontItalic"
PropertyChanged "Font"
End Property

Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_Description = " ."
Attribute FontUnderline.VB_ProcData.VB_Invoke_Property = ";Font"
FontUnderline = TextBox.FontUnderline
End Property

Public Property Let FontUnderline(ByVal NewValue As Boolean)
TextBox.FontUnderline = NewValue
Set objFont = TextBox.Font
PropertyChanged "FontUnderline"
PropertyChanged "Font"
End Property

Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_Description = " ."
Attribute FontStrikethru.VB_ProcData.VB_Invoke_Property = ";Font"
FontStrikethru = TextBox.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal NewValue As Boolean)
TextBox.FontStrikethru = NewValue
Set objFont = TextBox.Font
PropertyChanged "FontStrikethru"
PropertyChanged "Font"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = " ."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Enabled = varEnabled
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
varEnabled = NewValue
UserControl.Enabled = NewValue
TextBox.Enabled = NewValue
RefreshControlState
PropertyChanged "Enabled"
End Property

Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "    ."
Attribute Locked.VB_ProcData.VB_Invoke_Property = ";Behavior"
Locked = varLocked
End Property

Public Property Let Locked(ByVal NewValue As Boolean)
varLocked = NewValue
TextBox.Locked = NewValue
RefreshControlState
PropertyChanged "Locked"
End Property

Public Property Get FreezeEvents() As Boolean
Attribute FreezeEvents.VB_Description = "  ."
Attribute FreezeEvents.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute FreezeEvents.VB_MemberFlags = "400"
FreezeEvents = varFreezeEvents
End Property

Public Property Let FreezeEvents(ByVal NewValue As Boolean)
varFreezeEvents = NewValue
If varFreezeEvents Then
  If varPosted Then varPosted = False
  If varKeyInputFlag Then varKeyInputFlag = False
  tmrDelayType.Enabled = False
  tmrDelayType.Interval = 0&
  varDelayTypeLast = 0&
  tmrAutoType.Enabled = False
  tmrAutoType.Interval = 0&
  varAutoTypeLast = 0&
  varAutoTypeCnt = 0&
End If
PropertyChanged "FreezeEvents"
End Property

Public Property Get Mask() As String
Attribute Mask.VB_Description = "    (    ). : # (), & ( ), $ (), @ (  ), ! ( )."
Attribute Mask.VB_ProcData.VB_Invoke_Property = ";Behavior"
Mask = varMask
End Property

Public Property Let Mask(ByVal NewValue As String)
varMask = NewValue
RefreshControlMask
PropertyChanged "Mask"
End Property

Public Property Get DataType() As DataTypes
Attribute DataType.VB_Description = " ,   ."
Attribute DataType.VB_ProcData.VB_Invoke_Property = ";Data"
DataType = varDataType
End Property

Public Property Let DataType(ByVal NewValue As DataTypes)
If varDataType <> NewValue Then
  fBusy = True
  TextBox.Text = vbNullString
  fBusy = False
  varValue = Null
  PropertyChanged "Text"
  PropertyChanged "Value"
  If Not varFreezeEvents Then RaiseEvent Change
End If
varDataType = NewValue
RefreshControlMask
PropertyChanged "DataType"
End Property

Public Property Get Text() As String
Attribute Text.VB_Description = "  ."
Attribute Text.VB_ProcData.VB_Invoke_Property = ";Text"
Attribute Text.VB_UserMemId = 0
Text = TextBox.Text
End Property

Public Property Let Text(ByVal NewValue As String)
TextBox.Text = NewValue
ProcessingText
PropertyChanged "Text"
End Property

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "  ."
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = ";Text"
ToolTipText = TextBox.ToolTipText
End Property

Public Property Let ToolTipText(ByVal NewValue As String)
TextBox.ToolTipText = NewValue
PropertyChanged "ToolTipText"
End Property

Public Property Get Value() As Variant
Attribute Value.VB_Description = " ."
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Data"
Value = varValue
End Property

Public Property Let Value(ByVal NewValue As Variant)
varValue = NewValue
ProcessingValue
PropertyChanged "Value"
End Property

Public Property Get SelStart() As Long
Attribute SelStart.VB_Description = "  ."
Attribute SelStart.VB_MemberFlags = "400"
SelStart = TextBox.SelStart
End Property

Public Property Let SelStart(ByVal NewValue As Long)
TextBox.SelStart = NewValue
PropertyChanged "SelStart"
End Property

Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "  ."
Attribute SelLength.VB_MemberFlags = "400"
SelLength = TextBox.SelLength
End Property

Public Property Let SelLength(ByVal NewValue As Long)
TextBox.SelLength = NewValue
PropertyChanged "SelLength"
End Property

Public Property Get SelText() As String
Attribute SelText.VB_Description = " ."
Attribute SelText.VB_MemberFlags = "400"
SelText = TextBox.SelText
End Property

Public Property Let SelText(ByVal NewValue As String)
TextBox.SelText = NewValue
ProcessingText
PropertyChanged "SelText"
End Property

Public Sub SelectAll()
Attribute SelectAll.VB_Description = "     ."
TextBox.SelStart = 0
TextBox.SelLength = Len(TextBox.Text)
End Sub

Public Property Get MaxLength() As Long
Attribute MaxLength.VB_Description = "   ."
Attribute MaxLength.VB_ProcData.VB_Invoke_Property = ";Behavior"
MaxLength = TextBox.MaxLength
End Property

Public Property Let MaxLength(ByVal NewValue As Long)
TextBox.MaxLength = NewValue
PropertyChanged "MaxLength"
End Property

Public Property Get PasswordChar() As String
Attribute PasswordChar.VB_Description = "   ."
Attribute PasswordChar.VB_ProcData.VB_Invoke_Property = ";Behavior"
PasswordChar = TextBox.PasswordChar
End Property

Public Property Let PasswordChar(ByVal NewValue As String)
TextBox.PasswordChar = NewValue
PropertyChanged "PasswordChar"
End Property

Public Property Get CausesValidation() As Boolean
Attribute CausesValidation.VB_Description = "    ."
Attribute CausesValidation.VB_ProcData.VB_Invoke_Property = ";Behavior"
CausesValidation = varCausesValidation
End Property

Public Property Let CausesValidation(ByVal NewValue As Boolean)
varCausesValidation = NewValue
PropertyChanged "CausesValidation"
End Property

Public Sub Refresh()
Attribute Refresh.VB_Description = " ."
Attribute Refresh.VB_UserMemId = -550
RefreshControlValue
UserControl.Refresh
TextBox.Refresh
RefreshControlState
End Sub

Private Sub RefreshControlState()
If varEnabled Then
  If varLocked Then
    TextBox.BackColor = SystemColorConstants.vb3DFace
    TextBox.ForeColor = SystemColorConstants.vbWindowText
  Else
    TextBox.BackColor = varBackColor
    TextBox.ForeColor = varForeColor
  End If
Else
  TextBox.BackColor = SystemColorConstants.vb3DFace
  TextBox.ForeColor = SystemColorConstants.vbGrayText
End If
UserControl.BackColor = TextBox.BackColor
End Sub

Private Sub RefreshControlValue()
Dim S As String
S = TextBox.Text
On Error Resume Next
varValue = ParseValue(S, varDataType)
If Err.Number <> 0 Then varValue = Null
On Error GoTo 0
fBusy = True
If IsNull(varValue) Then
  TextBox.Text = vbNullString
Else
  TextBox.Text = FormatValue(varValue, varDataType)
End If
fBusy = False
End Sub

Private Sub RefreshControlMask()
Select Case varDataType
  Case DataTypes.DataTypeText
    varCurrentMask = varMask
  Case DataTypes.DataTypeInteger
    varCurrentMask = vbNullString
  Case DataTypes.DataTypeFixed1
    varCurrentMask = vbNullString
  Case DataTypes.DataTypeFixed2
    varCurrentMask = vbNullString
  Case DataTypes.DataTypeFixed3
    varCurrentMask = vbNullString
  Case DataTypes.DataTypeFixed4
    varCurrentMask = vbNullString
  Case DataTypes.DataTypeCurrency
    varCurrentMask = vbNullString
  Case DataTypes.DataTypeDate
    varCurrentMask = "##.##.####"
  Case DataTypes.DataTypeTime
    varCurrentMask = "##:##:##"
  Case DataTypes.DataTypeDateTime
    varCurrentMask = "##.##.#### ##:##:##"
End Select
End Sub

Private Sub ProcessingText()
Dim S As String
S = TextBox.Text
On Error Resume Next
varValue = ParseValue(S, varDataType)
If Err.Number <> 0 Then varValue = Null
On Error GoTo 0
fBusy = True
If IsNull(varValue) Then
  TextBox.Text = vbNullString
Else
  TextBox.Text = FormatValue(varValue, varDataType)
End If
fBusy = False
End Sub

Private Sub ProcessingValue()
fBusy = True
If IsNull(varValue) Then
  TextBox.Text = vbNullString
Else
  TextBox.Text = FormatValue(varValue, varDataType)
End If
fBusy = False
End Sub

Private Sub DelayTypeProc()
tmrDelayType.Enabled = False
tmrDelayType.Interval = 0&
varDelayTypeLast = 0&
If varDelayTypeSelect Then
  TextBox.SelStart = 0
  TextBox.SelLength = Len(TextBox.Text)
End If
If Not varFreezeEvents Then RaiseEvent DelayType
End Sub

Private Sub AutoTypeProc()
tmrAutoType.Enabled = False
tmrAutoType.Interval = 0&
varAutoTypeLast = 0&
varAutoTypeCnt = 0&
If varAutoTypeSelect Then
  TextBox.SelStart = 0
  TextBox.SelLength = Len(TextBox.Text)
End If
If Not varFreezeEvents Then RaiseEvent AutoType
If varDelayTypeTime > 0& Then DelayTypeProc
End Sub

Private Sub objFont_FontChanged(ByVal PropertyName As String)
Set UserControl.Font = TextBox.Font
PropertyChanged "Font"
End Sub

Private Sub TextBox_Change()
If varPosted Then
  Dim M As String, P As Long, L As Long, fState As Boolean
  varPosted = False
  If varLastKeyAscii <> vbKeyBack Then
    fState = fBusy
    fBusy = True
    P = TextBox.SelStart
    L = TextBox.SelLength
    M = Mid$(varCurrentMask, P + 1, 1)
    Select Case M
      Case vbNullString
      Case "#" ' 
      Case "&" ' 
      Case "$" ' A...Z
      Case "@" '  
      Case "!" ' 
      Case Else
        TextBox.SelText = M
        TextBox.SelStart = P
        TextBox.SelLength = Len(M)
    End Select
    fBusy = fState
  End If
End If
If fBusy Then Exit Sub

'DelayType
If Len(TextBox.Text) = 0 Then
  tmrDelayType.Enabled = False
  tmrDelayType.Interval = 0&
  varDelayTypeLast = 0&
Else
  If Ambient.UserMode Then
    If varDelayTypeTime > 0& Then
      varDelayTypeLast = InternalGetTickCount()
      If Not tmrDelayType.Enabled Then
        tmrDelayType.Interval = varDelayTypeTime
        tmrDelayType.Enabled = True
      End If
    End If
  End If
End If

'Key input
If Ambient.UserMode Then
  Dim S As String
  If varKeyInputFlag Then
    varKeyInputFlag = False
  Else
    If Len(varCurrentMask) > 0 Then
      If Len(TextBox.Text) > 0 Then
        If CheckMask(TextBox.Text, varCurrentMask, S) Then
          If Len(S) = Len(varCurrentMask) Then
            If S <> TextBox.Text Then
              fBusy = True
              P = TextBox.SelStart
              L = TextBox.SelLength
              TextBox.Text = S
              TextBox.SelStart = P
              TextBox.SelLength = L
              fBusy = False
            End If
          End If
        Else
          TextBox.SelStart = 0
          TextBox.SelLength = Len(TextBox.Text)
        End If
      End If
    End If
  End If
End If

If Not varFreezeEvents Then RaiseEvent Change
End Sub

Private Sub TextBox_GotFocus()
If varPosted Then varPosted = False
If varKeyInputFlag Then varKeyInputFlag = False
tmrDelayType.Enabled = False
tmrDelayType.Interval = 0&
varDelayTypeLast = 0&
tmrAutoType.Enabled = False
tmrAutoType.Interval = 0&
varAutoTypeLast = 0&
varAutoTypeCnt = 0&
fBusy = True
Select Case varDataType
  Case DataTypes.DataTypeText
  Case DataTypes.DataTypeInteger
    TextBox.Text = Trim$(TextBox.Text)
  Case DataTypes.DataTypeFixed1, DataTypes.DataTypeFixed2, DataTypes.DataTypeFixed3, DataTypes.DataTypeFixed4
    TextBox.Text = Trim$(TextBox.Text)
  Case DataTypes.DataTypeCurrency
    TextBox.Text = Trim$(TextBox.Text)
  Case DataTypes.DataTypeDate
    TextBox.Text = Trim$(TextBox.Text)
  Case DataTypes.DataTypeTime
    TextBox.Text = Trim$(TextBox.Text)
  Case DataTypes.DataTypeDateTime
    TextBox.Text = Trim$(TextBox.Text)
End Select
fBusy = False
If varAutoSelect Then
  TextBox.SelStart = 0
  TextBox.SelLength = Len(TextBox.Text)
End If
If TextBox.SelLength = 0 Then
  Dim M As String, P As Long, L As String
  P = TextBox.SelStart
  L = TextBox.SelLength
  M = Mid$(varCurrentMask, P + 1, 1)
  Select Case M
    Case vbNullString
    Case "#" ' 
    Case "&" ' 
    Case "$" ' A...Z
    Case "@" '  
    Case "!" ' 
    Case Else
      varKeyInputFlag = True
      TextBox.SelText = M
      TextBox.SelStart = P
      TextBox.SelLength = Len(M)
  End Select
End If
End Sub

Private Sub TextBox_KeyDown(KeyCode As Integer, Shift As Integer)
If varPosted Then varPosted = False
If varDelayTypeTime > 0& Then
  If Shift = 0 Then
    Select Case KeyCode
      Case vbKeyReturn
        KeyCode = 0
        If Len(TextBox.Text) > 0 Then
          DelayTypeProc
        End If
      Case vbKeyEscape
        KeyCode = 0
        varKeyInputFlag = True
        TextBox.Text = vbNullString
    End Select
  End If
End If
If Not varFreezeEvents Then RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub TextBox_KeyPress(KeyAscii As Integer)
If varPosted Then varPosted = False
If Not varFreezeEvents Then RaiseEvent KeyPress(KeyAscii)
Dim T As String, S As String, P As Long, L As Long, M As String, Z As String, I As Long
T = TextBox.Text
S = TextBox.SelText
P = TextBox.SelStart
L = TextBox.SelLength
If KeyAscii >= 32 Then
  Select Case varDataType
    Case DataTypes.DataTypeText
    Case DataTypes.DataTypeInteger
      Select Case KeyAscii
        Case vbKey0 To vbKey9
        Case Else
          KeyAscii = 0
      End Select
    Case DataTypes.DataTypeFixed1, DataTypes.DataTypeFixed2, DataTypes.DataTypeFixed3, DataTypes.DataTypeFixed4
      Select Case KeyAscii
        Case vbKey0 To vbKey9
        Case Asc(","), Asc(".")
          KeyAscii = Asc(".")
        Case Else
          KeyAscii = 0
      End Select
    Case DataTypes.DataTypeCurrency
      Select Case KeyAscii
        Case vbKey0 To vbKey9
        Case Asc(","), Asc(".")
          KeyAscii = Asc(".")
        Case Else
          KeyAscii = 0
      End Select
    Case DataTypes.DataTypeDate
      Select Case KeyAscii
        Case vbKey0 To vbKey9
        Case Asc(","), Asc("."), Asc("/"), Asc("-")
          KeyAscii = Asc(".")
        Case Else
          KeyAscii = 0
      End Select
    Case DataTypes.DataTypeTime
      Select Case KeyAscii
        Case vbKey0 To vbKey9
        Case Asc(":"), Asc("/"), Asc("-")
          KeyAscii = Asc(":")
        Case Else
          KeyAscii = 0
      End Select
    Case DataTypes.DataTypeDateTime
      Select Case KeyAscii
        Case vbKey0 To vbKey9
        Case 32
        Case Asc(","), Asc("."), Asc("/"), Asc("-")
          KeyAscii = Asc(".")
        Case Asc(":"), Asc("/"), Asc("-")
          KeyAscii = Asc(":")
        Case Else
          KeyAscii = 0
      End Select
  End Select
  If Len(varCurrentMask) = 0 Then
    Select Case varDataType
      Case DataTypes.DataTypeInteger
      Case DataTypes.DataTypeFixed1, DataTypes.DataTypeFixed2, DataTypes.DataTypeFixed3, DataTypes.DataTypeFixed4
        If KeyAscii = Asc(".") Then
          If InStr(T, ".") > 0 Then
            If InStr(S, ".") = 0 Then
              KeyAscii = 0
            End If
          End If
        End If
      Case DataTypes.DataTypeCurrency
        If KeyAscii = Asc(".") Then
          If InStr(T, ".") > 0 Then
            If InStr(S, ".") = 0 Then
              KeyAscii = 0
            End If
          End If
        End If
    End Select
  Else
    M = Mid$(varCurrentMask, P + 1, 1)
    Z = UCase$(Chr$(KeyAscii))
    Select Case M
      Case vbNullString
        KeyAscii = 0
      Case "#" ' 
        I = InStr(CharsDecDigits, Z)
        If I = 0 Then
          KeyAscii = 0
        Else
          KeyAscii = Asc(Z)
        End If
      Case "&" ' 
        I = InStr(CharsHexDigits, Z)
        If I = 0 Then
          KeyAscii = 0
        Else
          KeyAscii = Asc(Z)
        End If
      Case "$" ' A...Z
        I = InStr(CharsLetters, Z)
        If I = 0 Then
          KeyAscii = 0
        Else
          KeyAscii = Asc(Z)
        End If
      Case "@" '  
        I = InStr(CharsDecDigits & CharsLetters, Z)
        If I = 0 Then
          KeyAscii = 0
        Else
          KeyAscii = Asc(Z)
        End If
      Case "!" ' 
      Case Else
        KeyAscii = Asc(M)
        Select Case Mid$(varCurrentMask, P + L + 1, 1)
          Case vbNullString
          Case "#"
            If InStr(CharsDecDigits, Z) > 0 Then
              TextBox.SelStart = P + L
              TextBox.SelLength = 0
              KeyAscii = Asc(Z)
            End If
          Case "&"
            If InStr(CharsHexDigits, Z) > 0 Then
              TextBox.SelStart = P + L
              TextBox.SelLength = 0
              KeyAscii = Asc(Z)
            End If
          Case "$"
            If InStr(CharsLetters, Z) > 0 Then
              TextBox.SelStart = P + L
              TextBox.SelLength = 0
              KeyAscii = Asc(Z)
            End If
          Case "@"
            If InStr(CharsLetters, Z) > 0 Then
              TextBox.SelStart = P + L
              TextBox.SelLength = 0
              KeyAscii = Asc(Z)
            End If
          Case "!"
            TextBox.SelStart = P + L
            TextBox.SelLength = 0
            KeyAscii = Asc(Z)
          Case Else
        End Select
    End Select
  End If
End If

'AutoType
If KeyAscii < 32 And KeyAscii > 0 Then
  tmrAutoType.Enabled = False
  tmrAutoType.Interval = 0&
  varAutoTypeLast = 0&
  varAutoTypeCnt = 0&
Else
  If Ambient.UserMode Then
    If varAutoTypeTime > 0& Then
      varAutoTypeLast = InternalGetTickCount()
      varAutoTypeCnt = varAutoTypeCnt + 1&
      If Not tmrAutoType.Enabled Then
        tmrAutoType.Interval = varAutoTypeTime / 10
        tmrAutoType.Enabled = True
      End If
    End If
  End If
End If

varPosted = True
varLastKeyAscii = KeyAscii
varLastSelStart = P
varLastSelLength = L
If KeyAscii > 0 Then varKeyInputFlag = True
End Sub

Private Sub TextBox_KeyUp(KeyCode As Integer, Shift As Integer)
If varPosted Then varPosted = False
If Not varFreezeEvents Then RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub TextBox_LostFocus()
If varPosted Then varPosted = False
If varKeyInputFlag Then varKeyInputFlag = False
tmrDelayType.Enabled = False
tmrDelayType.Interval = 0&
varDelayTypeLast = 0&
tmrAutoType.Enabled = False
tmrAutoType.Interval = 0&
varAutoTypeLast = 0&
varAutoTypeCnt = 0&
RefreshControlValue
If varAutoSelect Then
  TextBox.SelStart = 0
  TextBox.SelLength = Len(TextBox.Text)
End If
End Sub

Private Sub TextBox_Validate(Cancel As Boolean)
If varPosted Then varPosted = False
If varCausesValidation Then
  If Not varFreezeEvents Then RaiseEvent Validate(Cancel)
End If
If Cancel Then Exit Sub
RefreshControlValue
End Sub

Private Sub tmrAutoType_Timer()
If varAutoTypeLast = 0& Then
  tmrAutoType.Enabled = False
  tmrAutoType.Interval = 0&
  varAutoTypeCnt = 0&
  Exit Sub
End If
Dim T As Long
T = InternalGetTickCount()
If (T - varAutoTypeLast) >= varAutoTypeTime Then
  If varAutoTypeCnt > 2& Then
    AutoTypeProc
  Else
    tmrAutoType.Enabled = False
    tmrAutoType.Interval = 0&
    varAutoTypeLast = 0&
    varAutoTypeCnt = 0&
  End If
End If
End Sub

Private Sub tmrDelayType_Timer()
If varDelayTypeLast = 0& Then
  tmrDelayType.Enabled = False
  tmrDelayType.Interval = 0&
  Exit Sub
End If
Dim T As Long
T = InternalGetTickCount()
If (T - varDelayTypeLast) >= varDelayTypeTime Then
  DelayTypeProc
End If
End Sub

Private Sub UserControl_Hide()
tmrDelayType.Enabled = False
tmrDelayType.Interval = 0&
varDelayTypeLast = 0&
tmrAutoType.Enabled = False
tmrAutoType.Interval = 0&
varAutoTypeLast = 0&
varAutoTypeCnt = 0&
End Sub

Private Sub UserControl_Initialize()
Set objFont = TextBox.Font
End Sub

Private Sub UserControl_InitProperties()
Set TextBox.Font = Ambient.Font
varEnabled = True
varLocked = False
varBackColor = SystemColorConstants.vbWindowBackground
varForeColor = SystemColorConstants.vbWindowText
varCausesValidation = False
varFreezeEvents = False
varAutoSelect = True
varMask = vbNullString
varDataType = DataTypeText
varValue = Null
varAutoTypeTime = 0&
varAutoTypeSelect = True
varDelayTypeTime = 0&
varDelayTypeSelect = True
Set objFont = TextBox.Font
Set UserControl.Font = objFont
RefreshControlState
RefreshControlMask
RefreshControlValue
UserControl_Resize
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
fBusy = True
With PropBag
  varDelayTypeTime = .ReadProperty("DelayTypeTime", 0&)
  varDelayTypeSelect = .ReadProperty("DelayTypeSelect", True)
  varAutoTypeTime = .ReadProperty("AutoTypeTime", 0&)
  varAutoTypeSelect = .ReadProperty("AutoTypeSelect", True)
  TextBox.Alignment = .ReadProperty("Alignment", AlignmentConstants.vbLeftJustify)
  TextBox.MousePointer = .ReadProperty("MousePointer", MousePointerConstants.vbDefault)
  Set TextBox.MouseIcon = .ReadProperty("MouseIcon", Nothing)
  varAutoSelect = .ReadProperty("AutoSelect", True)
  varBackColor = .ReadProperty("BackColor", SystemColorConstants.vbWindowBackground)
  varForeColor = .ReadProperty("ForeColor", SystemColorConstants.vbWindowText)
  Set TextBox.Font = .ReadProperty("Font", Ambient.Font)
  varEnabled = .ReadProperty("Enabled", True)
  varLocked = .ReadProperty("Locked", False)
  varFreezeEvents = .ReadProperty("FreezeEvents", False)
  varMask = .ReadProperty("Mask", vbNullString)
  varDataType = .ReadProperty("DataType", DataTypes.DataTypeText)
  TextBox.Text = .ReadProperty("Text", vbNullString)
  TextBox.ToolTipText = .ReadProperty("ToolTipText", vbNullString)
  TextBox.MaxLength = .ReadProperty("MaxLength", 0&)
  TextBox.PasswordChar = .ReadProperty("PasswordChar", vbNullString)
  varCausesValidation = .ReadProperty("CausesValidation", False)
End With
fBusy = False
Set objFont = TextBox.Font
Set UserControl.Font = objFont
RefreshControlState
RefreshControlMask
RefreshControlValue
UserControl_Resize
ProcessingValue
End Sub

Private Sub UserControl_Resize()
If fBusyResize Then Exit Sub
fBusyResize = True
TextBox.Move UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, UserControl.ScaleHeight
UserControl.Width = TextBox.Width * Screen.TwipsPerPixelX
UserControl.Height = TextBox.Height * Screen.TwipsPerPixelY
fBusyResize = False
End Sub

Private Sub UserControl_Show()
UserControl_Resize
End Sub

Private Sub UserControl_Terminate()
tmrDelayType.Enabled = False
tmrAutoType.Enabled = False
Set objFont = Nothing
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
With PropBag
  .WriteProperty "DelayTypeTime", varDelayTypeTime, 0&
  .WriteProperty "DelayTypeSelect", varDelayTypeSelect, True
  .WriteProperty "AutoTypeTime", varAutoTypeTime, 0&
  .WriteProperty "AutoTypeSelect", varAutoTypeSelect, True
  .WriteProperty "Alignment", TextBox.Alignment, AlignmentConstants.vbLeftJustify
  .WriteProperty "MousePointer", TextBox.MousePointer, MousePointerConstants.vbDefault
  .WriteProperty "MouseIcon", TextBox.MouseIcon, Nothing
  .WriteProperty "AutoSelect", varAutoSelect, True
  .WriteProperty "BackColor", varBackColor, SystemColorConstants.vbWindowBackground
  .WriteProperty "ForeColor", varForeColor, SystemColorConstants.vbWindowText
  .WriteProperty "Font", TextBox.Font, Ambient.Font
  .WriteProperty "Enabled", varEnabled, True
  .WriteProperty "Locked", varLocked, False
  .WriteProperty "FreezeEvents", varFreezeEvents, False
  .WriteProperty "Mask", varMask, vbNullString
  .WriteProperty "DataType", varDataType, DataTypes.DataTypeText
  .WriteProperty "Text", TextBox.Text, vbNullString
  .WriteProperty "ToolTipText", TextBox.ToolTipText, vbNullString
  .WriteProperty "MaxLength", TextBox.MaxLength, 0&
  .WriteProperty "PasswordChar", TextBox.PasswordChar, vbNullString
  .WriteProperty "CausesValidation", varCausesValidation, False
End With
End Sub
